#ifndef FLY_FILE_UTILS_H
#define FLY_FILE_UTILS_H

#include <fly/flytaggedbool.h>

#include <stdlib.h>

//#if defined(__linux__) || defined (_linux_) || defined(linux)
//#include <linux/limits.h> //for PATH_MAX, NAME_MAX
//#else
#include <limits.h>
//#endif
//since some moment ARG_MAX may be not defined. so try so or get rid of it at all
//#ifndef ARG_MAX
//#define ARG_MAX (sysconf(_SC_ARG_MAX))
//#endif

using Display = struct _XDisplay;
using Window = unsigned long;

#include <fly/flydeapi.h>

#include <vector>
#include <string>
#include <map>

//#ifdef __cplusplus
//extern "C"
//{
//#endif

//some popular program names
#define XDG_OPEN_UTIL           "xdg-open" // src
#define XDG_PROP_UTIL           "xdg-prop" // src
#define XDG_EDIT_UTIL           "xdg-edit" // src

#define FLYFM_OPEN_MANAGER      "fly-open"
#define FLYFM_OPEN   			"fly-open --exec" // srcs
#define FLYFM_OPEN_WITH  		"fly-open --open" // srcs

#define FLYFM_PROP_MANAGER      "fly-props"
#define FLYFM_PROP    			"fly-props --show" // srcs

#define FLYFM_FILE_MANAGER      "fly-fm" // src

#define FLYFM_FOPS_MANAGER   	"fly-fops"
#define FLYFM_REMOVE 			"fly-fops --remove"	// srcs
#define FLYFM_MOVE   			"fly-fops --move"	// srcs dst
#define FLYFM_COPY   			"fly-fops --copy"	// srcs dst
#define FLYFM_MOVE_TO  			"fly-fops -s --move"	// srcs dst
#define FLYFM_COPY_TO 			"fly-fops -s --copy"	// srcs dst
#define FLYFM_RENAME   			"fly-fops --rename"	// srcs dst
#define FLYFM_TRASH  	 		"fly-fops --trash"	// srcs
#define FLYFM_RESTORE           "fly-fops --restore"
#define FLYFM_TRASH_SILENT		"fly-fops --silent --trash"	// srcs
#define FLYFM_TRASH_CLEAN 		"fly-fops --clean"
#define FLYFM_EMAIL 		    "fly-fops --email"

#define FLY_DTE_EDITOR	   		"fly-dtedit"

#define FLY_TERM                "fly-term"
#define FLY_TERM_EXEC           FLY_TERM" -e "      //at the end - command to execute
#define FLY_TERM_HOLD_EXEC      FLY_TERM" -hold -e "//at the end - command to execute

#define XTERM                   "xterm"
#define XTERM_EXEC              XTERM" -e "       //at the end - command to execute
#define XTERM_HOLD_EXEC         XTERM" -hold -e " //at the end - command to execute

#define X_TERM_EMU              "x-terminal-emulator"
#define X_TERM_EMU_EXEC         X_TERM_EMU" -e "       //at the end - command to execute
#define X_TERM_EMU_HOLD_EXEC    X_TERM_EMU" -hold -e " //at the end - command to execute


#ifndef CP_FILE_CMD
#if defined(__linux__) || defined (_linux_) || defined(linux)
#define CP_FILE_CMD "/bin/cp -f"
#else
#define CP_FILE_CMD "/bin/cp"
#endif
#endif

#ifndef CP_DIR_CMD
#define CP_DIR_CMD CP_FILE_CMD" -r"
#endif


#ifndef CP_FILE_PRESERVE_CMD
#if defined(__linux__) || defined (_linux_) || defined(linux)
#define CP_FILE_PRESERVE_CMD CP_FILE_CMD" -p"
#else
#define CP_FILE_PRESERVE_CMD CP_FILE_CMD
#endif
#endif

#ifndef CP_DIR_PRESERVE_CMD
#if defined(__linux__) || defined (_linux_) || defined(linux)
#define CP_DIR_PRESERVE_CMD CP_DIR_CMD" -p"
#else
#define CP_DIR_PRESERVE_CMD CP_DIR_CMD
#endif
#endif

#ifndef MV_CMD
#if defined(__linux__) || defined (_linux_) || defined(linux)
#define MV_CMD "/bin/mv -f"
#else
#define MV_CMD "/bin/mv"
#endif
#endif

#ifndef RM_FILE_CMD
#define RM_FILE_CMD "/bin/rm -f"
#endif

#ifndef RM_DIR_CMD
#define RM_DIR_CMD RM_FILE_CMD" -r"
#endif

#ifndef MKDIR_CMD
#define MKDIR_CMD "/bin/mkdir -p"
#endif

//somestuff for WM remote command
#define VAR_RUN_DIR "/var/run"
#define FLY_TMP_DIR "/tmp"
#define FLY_FIFO_PREFIX "fly-wm-"

#define FLYWM_UPDATE_VAL_CMD    "FLYWM_UPDATE_VAL"
#define FLYWM_RESTART_CMD       "FLYWM_RESTART"

//fly-wm shared path
#define FLYWM_SHARED_DIR     "/usr/share/fly-wm"
#define FLYWM_SOUNDS_DIR     "sounds"
#define FLYWM_IMAGES_DIR     "images"
#define FLYWM_KEYMAPS_DIR    "keymaps"
#define FLYWM_DECOR_DIR      "decorations"

// user paths
#define FLY_THEME_DIR           "theme"
#define FLY_CURRENT_THEME_NAME  "current.themerc"
#define FLY_DEFAULT_THEME_NAME  "default.themerc"

#define FLY_THEME_MASTER_DIR    "theme.master"
#define FLY_THEME_MASTER_NAME   "themerc"

#define FLY_TRAY_THEME_NAME_BLACK "fly-astra-flat-black"
#define FLY_TRAY_THEME_NAME_WHITE "fly-astra-flat-white"

#define FLY_PALETTE             "paletterc"

#define FLY_CONTROL_PANEL_DIR   "controlpanel" /*obsolete*/
#define FLY_DESKTOP_DIR         "Desktop"
#define FLY_DESKTOPS_DIR        "Desktops"
#define FLY_TOOLBAR_DIR         "toolbar"
#define FLY_MY_DOCUMENTS_DIR    "Documents"
#define FLY_START_MENU_DIR      "startmenu"
#define FLY_USER_TMP_DIR        "tmp"

//app shared paths (usually inside /usr/share/fly/...) - TODO: get all from flybuild vars
#define FLY_SHARED_DIR             "/usr/share/fly"
//where used?
#define FLY_SHARED_DOCS_DIR        "/usr/share/doc/fly"

#ifdef FLY_INS_DOCS
#define FLY_SHARED_HTML_DOCS_DIR   FLY_INS_DOCS
#else
#define FLY_SHARED_HTML_DOCS_DIR   FLY_SHARED_DOCS_DIR"/qthelp"
#endif

#ifdef FLY_INS_TRANS
#define FLY_SHARED_TRANS_DIR       FLY_INS_TRANS
#else
#define FLY_SHARED_TRANS_DIR       FLY_SHARED_DIR"/translations"
#endif

#define DEFAULT_APP_ICON            "system-run"
#define DEFAULT_APP_ICON_CTX        "Actions"

bool flyCopyFile(const char *src, const char *dst);

const std::string &GetFlyDir(FlyDir d); // returns refs to static strings like "~/.fly[/...]"
void 		ResetFlyDirs();		 //reset all cached dir paths

// find files by pattern in dir with possible traverse in subfolders (depth>0)
// only limited pattern accepted ("*name" or "name*")
using FilesOnly = Fly::tagged_bool<class FilesOnly_tag>;
using FileNamesOnly = Fly::tagged_bool<class FileNamesOnly_tag>;
bool GetFileList(std::vector<std::string> *fileList, const char *dir, int depthLevel, const char *pattern, FilesOnly filesOnly = FilesOnly{false});
bool GetFileNameList(std::vector<std::string> *fileList, const char *dir, int depthLevel, const char *pattern, FilesOnly filesOnly = FilesOnly{false});

//list of 'f' subdirs in XDG standard dirs
std::vector<std::string> xdgConfigDirs(const char *f);
std::vector<std::string> xdgDataDirs(const char *f);
//lookup "f" in XDG standard dirs
std::string findInXDGConfigDirs(const char *f);
std::string findInXDGDataDirs(const char *f);

//lookup 1st existed "autostart" dir in XDG standard dirs
std::string autostartDir();
//lookup all existed "autostart" dirs in XDG standard dirs
std::vector<std::string> autostartDirs();

//returns 0 - OK; -1,-2,-3,... < 0 - errors in args, folder doesnt exist, permission denied, etc
using ProgsOnly = Fly::tagged_bool<class ProgsOnly_tag>;
int putEntryToRecentsMenu(const char *dtopentry, const char *icon, Display *, ProgsOnly progsOnly = ProgsOnly{true});

//get PPid field from /proc/pid/status
pid_t getPPid(pid_t pid);

//get run directory(dirPathOnly) or full cmdline by pid from /proc/pid/cmdline
using DirPathOnly = Fly::tagged_bool<class DirPathOnly_tag>;
std::string getCmdLine(pid_t pid = 0, DirPathOnly dirPathOnly = DirPathOnly{true});

using ApllyByXrdb = Fly::tagged_bool<class ApllyByXrdb_tag>;
bool setXrdbParameterInFile(const char *filePath,
						const char *paramName,const char *sep, const char *paramValue,
                        ApllyByXrdb applyByXrdb = ApllyByXrdb{false});

//unix 'which' command C++-implementation
std::string FindFileInPATH(const char *file);

//return pointer to file extension ( "abcd.ext" - pointer to "ext" )
//return NULL if no extension or its length > extensionMaxLendth
bool fileNameExtension(const char *fileNamePath, unsigned int extensionMaxLendth=4);

using CheckExists = Fly::tagged_bool<class CheckExists_tag>;
std::string resolveSymLink(const char *path, CheckExists checkExists = CheckExists{false});
bool makeRelativeSymlink(const char *dst, const char *slink);
bool isPathBusy(const char *path);

//remove dir recursively
// dir - path to dir
// inside_only - delete inside dir but not dir itself
// keep_dotdirectory_file - if true don't delete .directory file in dir
using InsideOnly = Fly::tagged_bool<class InsideOnly_tag>;
using KeepDotDirectoryFile = Fly::tagged_bool<class KeepDotDirectoryFile_tag>;
bool rmdirRecursive(const char *dir, InsideOnly inside_only = InsideOnly{false},
                    KeepDotDirectoryFile keep_dotdirectory_file = KeepDotDirectoryFile{false});
//check if directory empty, if dont_check_dodirectory=true ignore .directory file
using IgnoreDotDirectoryFile = Fly::tagged_bool<class IgnoreDotDirectoryFile_tag>;
bool isDirEmpty(const char *path, IgnoreDotDirectoryFile ignoreDotDirectory = IgnoreDotDirectoryFile{false});

//make new path like /parentPath/baseName(i).ext, where 
// parentPath - destination file path
// baseName   - base name without extension
// ext        - extension with dot (".png",".desktop",etc), 
// delete_and_reuse_if_not_busy - flag delete and reuse existed file if it is not busy
// returns full file path and calculated index appended to base name
using DeleteAndReuseIfNotBusy = Fly::tagged_bool<class DeleteAndReuseIfNotBusy_tag>;
std::pair<std::string, int> MakeNewNumberedPath(const char *parentPath, const char *baseName, const char *ext,
                                                DeleteAndReuseIfNotBusy delete_and_reuse_if_not_busy = DeleteAndReuseIfNotBusy{false});

std::pair<std::string, int> MakeNewNumberedPath(const char *parentPath, const char *baseName, const char *ext,
                                                bool with_space=true, bool with_parentheses=true,
                                                int start_number=2, int stop_number=1024,
                                                DeleteAndReuseIfNotBusy delete_and_reuse_if_not_busy = DeleteAndReuseIfNotBusy{false});


//lock/unlock file, 'block' - block function or immediately return
//fid has to be the same between both lock/unlock!
using LockRead = Fly::tagged_bool<class LockRead_tag>;
using BlockingCall = Fly::tagged_bool<class BlockingCall_tag>;
bool flyLockFile(int fd, LockRead lockRead, BlockingCall block);
bool flyUnlockFile(int fd);

//find wall paper by short name (i.e. without full path and-or extension)
// the most suitable for screen size
std::string FindWallPaperByName(const char *name, int screenWidth, int screenHeight,
                                const char *svgConvertorFormat, const char * primaryColor);
std::string FixTooDarkColor(const std::string&);

std::string CreateShadeColor(const std::string& baseColor, double percent);
//create 10 colors ("color50", "color100", "color200" ... "color900") similar to Material Design
std::map<std::string,std::string> CreateShadeColors(const std::string& baseColor);
//returns #FFFFFF or #000000 as text color for base color
std::string textColorFor(const std::string& baseColor);

//get primary dark color but with the same text color
std::string GetPrimaryDarkColor(const std::string& primaryColor, bool sameTextColor=true);

std::string FindDefaultLogoPath(std::string logoName, int desktopWidth, int desktopHeight, std::string logoColor);
void CalcLogoPosition(int logoWidth, int logoHeight,
                      int desktopX, int desktopY, int desktopWidth, int desktopHeight, std::string pos, int *x, int *y);

// put environment variables like ~, $HOME, etc in returned path
std::string ExtractPathName(const char* name);

bool fileExists(const char *path, bool checkIfEmpty=false);
bool fileExists(const std::string &path, bool checkIfEmpty=false);

off_t flySizeOfPath(const char *path);

#endif
